<?php

namespace Netim\Database
{

    function createAsyncDb(\Record $rec)
    {
        $rec->
        setField("ID_OPE", array('type' => "int",'size' => 11))->
        setField("DOMAINE", array('type' => "varchar", 'size' => 255))->
        setField("CODE_OPE", array('type' => "varchar", 'size' => 50))->
        setField("DATE_OPE", array('type' => "datetime"))->
        setKey(array("ID_OPE"), "primary")->
        create("netim_async");
    }

    function createErrorDb(\Record $rec)
    {
        $rec->
        setField("ID_OPE", array('type' => "int",'size' => 11, 'is_null' => true))->
        setField("DOMAINE", array('type' => "varchar", 'size' => 255))->
        setField("CODE_OPE", array('type' => "varchar", 'size' => 50))->
        setField("DATE_OPE", array('type' => "datetime"))->
        setKey(array("DOMAINE", "CODE_OPE"), "primary")->
        create("netim_error");
    }

    function deleteAsyncDb(\Record $rec)
    {
        $rec->drop('netim_async');
    }

    function deleteErrorDb(\Record $rec)
    {
        $rec->drop('netim_error');
    }

    /*
    function isDomainInTable(\Record $rec, string $domain):bool
    {
        $res = $rec->
        select()->
        from('netim_async')->
        where('CODE_OPE', '=', 'domainCreate')->
        where('DOMAINE', '=', $domain)->numResults();
        return boolval($res);
    }
*/
    function getAsyncRequest(\Record $rec,string $code_ope,string $domain):bool
    {
        $res = $rec->
        select()->
        from('netim_async')->
        where('CODE_OPE', '=', $code_ope)->
        where('DOMAINE', '=', $domain)->
        numResults();

        return boolval($res);
    }

    function getError(\Record $rec, string $code_ope,string $domain)
    {
        $res = $rec->
        select()->
        from('netim_error')->
        where('CODE_OPE', '=', $code_ope)->
        where('DOMAINE', '=', $domain)->
        fetch();
        return $res ?? 0;
    }

    function addAsyncRequest(\Record $rec, $id_ope, string $code_ope,string $domain)
    {
        $date = new \DateTime();
        $rec->insert("netim_async", array("ID_OPE"=>$id_ope, "DOMAINE" => $domain, "CODE_OPE" => $code_ope, "DATE_OPE" => $date->format('Y-m-d H:i:s')));
    }
    
    function addError(\Record $rec, string $message, string $code_ope,string $domain, $id_ope = null)
    {
        $date = new \DateTime();
        $rec->insert("netim_error", array("ID_OPE"=>$id_ope, "DOMAINE" => $domain, "CODE_OPE" => $code_ope, "DATE_OPE" => $date->format('Y-m-d H:i:s'), 'MESSAGE' => $message));
    }

    function removeAsyncRequest(\Record $rec, $id_ope)
    {
        $rec->from("netim_async")->where("ID_OPE", '=', $id_ope)->delete();
    }

    function removeError(\Record $rec, string $code_ope,string $domain)
    {
        $rec->from("netim_error")->where("CODE_OPE", '=', $code_ope)->where("DOMAINE", '=', $domain)->delete();
    }

    function getAllAsyncRequests(\Record $rec):array
    {
        return $rec->select()->from('netim_async')->fetchall();
    }

    function getAllErrors(\Record $rec):array
    {
        return $rec->select()->from('netim_error')->fetchall();
    }
}